
//------------------------------------------------------------------------ make a date string
String makeDateString() {
  updateTime();                                   // get current time
  String dateString = "";
  String ho = String(hours);
  String mi = String(minutes);
  String da = String(days);
  String mo = monthName[months - 1];
  String ye = String(years);
  String wkd = dayName[wkday];

  if (hours < 10)   ho = "0" + ho;
  if (minutes < 10) mi = "0" + mi;
  if (days < 10)    da = "0" + da;
  ye = "20" + ye;

  dateString = wkd + " " + da + "/" + mo + "/" + ye + " " + ho + "/" + mi;
  return dateString;
}

//------------------------------------------------------------------------ move motor
void motor(boolean motOnOff) {
  if (motOnOff) digitalWrite(MOTORPIN, HIGH);
  if (motOnOff) digitalWrite(MOTORPIN, LOW);
}

//------------------------------------------------------------------------ RTC functions
void setupRTC() {
  rtc.begin(); // Call rtc.begin() to initialize the library
}


// ------------------------------------------------------------- update time
void updateTime() {
  rtc.update();
  minutes = int(rtc.minute());
  hours   = int(rtc.hour());
  days    = int(rtc.date());
  months  = int(rtc.month());
  years   = int(rtc.year());
  wkday   = int(rtc.day());
  Serial.println("updating time:");
  Serial.println(">>> " + String(hours) + ":" + String(minutes) + " " + String(days) + "." + String(months) + "." + String(years) + " weekday:" + String(wkday));
}

// -------------------------------------------------------------  set current time
void setRTC(int newHours , int newMinutes , int newDay , int newMonth , int newYear, int newWkDay) {
  rtc.setTime(0, newMinutes, newHours, newWkDay, newDay, newMonth, newYear);   // s, m, h, weekday, day, month, year
}
////////////////////////////////////////////////////////////////////////////////////////////////////// plot text

void plotText(String str, int x, int y, int scale, int space) {
  int pos = 0;
  Serial.println("plot string");
  Serial.println(str);
  for (int i = 0; i < str.length(); i++) {
    char c = char(str.charAt(i));
    if (byte(c) != 195) {
      if (c == ' ') {
        pos += scale;
      } else {
        plotChar(c, x + pos, y, scale);
        pos = pos + space;
        if (c == 'I' || c == 'i' ) pos -= scale / 1.1;
        if (c == ',' ) pos -= scale / 1.2;
      }
    }
  }
  Serial.println();
  releaseMotors();
}



////////////////////////////////////////////////////////////////////////////////////////////////////// plot character at x,y position

void plotChar(char c, int x, int y, int scale) {
  Serial.print(uint8_t(c));
  Serial.print(">");
  scale /= 4;
  uint8_t character = 38;
  if (uint8_t(c) > 64 and uint8_t(c) < 91) { //A...Z
    character = uint8_t(c) - 65;
  }
  if (uint8_t(c) > 96 and uint8_t(c) < 123) { //A...Z
    character = uint8_t(c) - 97;
  }
  if (uint8_t(c) > 47 and uint8_t(c) < 58) { //0...9
    character = uint8_t(c) - 22;
  }
  if (uint8_t(c) == 164 || uint8_t(c) == 132) { //ä,Ä
    character = 39;
  }
  if (uint8_t(c) == 182 || uint8_t(c) == 150) { //ö,Ö
    character = 40;
  }
  if (uint8_t(c) == 188 || uint8_t(c) == 156) { //ü,Ü
    character = 41;
  }
  if (uint8_t(c) == 44) { // ,
    character = 42;
  }
  if (uint8_t(c) == 45) { // -
    character = 43;
  }
  if (uint8_t(c) == 46) { // .
    character = 44;
  }
  if (uint8_t(c) == 33) { // !
    character = 45;
  }
  if (uint8_t(c) == 63) { // ?
    character = 46;
  }

  if (uint8_t(c) == 123) { /*{ ß*/
    character = 47;
  }
  if (uint8_t(c) == 39) { /*'*/
    character = 48;
  }
  if (uint8_t(c) == 38) { /*&*/
    character = 49;
  }
  if (uint8_t(c) == 43) { /*+*/
    character = 50;
  }
  if (uint8_t(c) == 58) { /*:*/
    character = 51;
  }
  if (uint8_t(c) == 59) { /*;*/
    character = 52;
  }
  if (uint8_t(c) == 34) { /*"*/
    character = 53;
  }
  if (uint8_t(c) == 35) { /*#*/
    character = 54;
  }
  if (uint8_t(c) == 40) { /*(*/
    character = 55;
  }
  if (uint8_t(c) == 41) { /*)*/
    character = 56;
  }
  if (uint8_t(c) == 61) { /*=*/
    character = 57;
  }
  if (uint8_t(c) == 64) { /*@*/
    character = 58;
  }
  if (uint8_t(c) == 42) { /***/
    character = 59;
  }
  if (uint8_t(c) == 125) { /*} Smiley*/
    character = 60;
  }
  if (uint8_t(c) == 126) { /*~ Open mouth Smiley*/
    character = 61;
  }
  if (uint8_t(c) == 36) { /*$ Heart*/
    character = 62;
  }

  Serial.println(character);
  for (int i = 0; i < 14; i++) {                   // go through each vector of the character    Serial.print("|| v:");

    int v = vector[character][i];
    if (v == 200) {                                // no more vectors in this array
      break;
    }
    if (v == 222) {                                // plot single point
      plot(true); plot(false);
    } else {
      int draw = 0;
      if (v > 99) {
        draw = 1;
        v -= 100;
      }
      int cx = v / 10;                             // get y ...
      int cy = v - cx * 10;                        // and x
      moveTo(x + cx * scale, y - cy * scale, draw);
    }
  }
}


////////////////////////////////////////////////////////////////////////////////////////////////////// plot

void plot(boolean penOnPaper) {
  digitalWrite(penPin, penOnPaper);
  if (penOnPaper != pPenOnPaper) delay(100);
  pPenOnPaper = penOnPaper;
}


////////////////////////////////////////////////////////////////////////////////////////////////////// move to
boolean moveTo(int xgoal, int ygoal, int dashed) {
  while (xgoal != xpos || ygoal != ypos) {

    if (dashed < 2) {
      plot(dashed); // dashed: 0= don't draw / 1=draw / 2... = draw dashed with variable dash width
    } else {
      plot((stepCount / dashed) % 2);
    }

    if (xgoal < xpos) {
      xpos--;
    }
    if (xgoal > xpos) {
      xpos++;
    }
    if (ygoal < ypos) {
      ypos--;
    }
    if (ygoal > ypos) {
      ypos++;
    }
    for (int i = 0; i < 4; i++) {
      digitalWrite(xPins[i], halfStep[xpos % 8][i]);
      digitalWrite(yPins[i], halfStep[ypos % 8][i]);
      delayMicroseconds(180);
    }
    stepCount++;
  }
  return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////// release motors

void releaseMotors() {
  for (int i = 0; i < 4; i++) {
    digitalWrite(xPins[i], 0);
    digitalWrite(yPins[i], 0);
  }
  plot(false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////// calibrate

boolean calibrate() {

  digitalWrite(penPin, false);
  xpos = 0;
  while (!digitalRead(endSwitch)) {
    xpos++;
    for (int i = 0; i < 4; i++) {
      digitalWrite(xPins[i], halfStep[xpos % 8][i]);
      delayMicroseconds(190);
    }
  }

  for (int i = 0; i < 20; i++) {
    xpos--;
    for (int i = 0; i < 4; i++) {
      digitalWrite(xPins[i], halfStep[xpos % 8][i]);
      delayMicroseconds(190);
    }
  }
  Serial.println("calibrated!");
  xpos = 5300;
  return true;
}
